Bug 1851243 - perl-Test-Fake-HTTPD: FTBFS with crypto-policies-20200625-1.gitb298a9e.fc33
Summary: perl-Test-Fake-HTTPD: FTBFS with crypto-policies-20200625-1.gitb298a9e.fc33
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: perl-Test-Fake-HTTPD
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Petr Pisar
QA Contact: Fedora Extras Quality Assurance
URL: https://koschei.fedoraproject.org/pac...
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-06-25 21:39 UTC by Jitka Plesnikova
Modified: 2020-06-26 12:11 UTC (History)
3 users (show)

Fixed In Version: perl-Test-Fake-HTTPD-0.08-12.fc33
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-06-26 12:11:26 UTC
Type: Bug


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Github masaki Test-Fake-HTTPD pull 5 0 None open Use stronger testing certificate 2020-06-26 12:11:26 UTC

Description Jitka Plesnikova 2020-06-25 21:39:29 UTC
Description of problem:
Package perl-Test-Fake-HTTPD fails to build from source in Fedora rawhide. I found the issue during perl 5.32 rebuild, but the build failed also with perl 5.30 with the error:

Can't accepted on 127.0.0.1:36691 at /usr/share/perl5/vendor_perl/Test/TCP.pm line 100.
    # No tests run!
    # No tests run!
#   Failed test 'No tests run for subtest "run_https_server"'
#   at t/11_https.t line 44.
cannot open port: 127.0.0.1:36691 at /usr/share/perl5/vendor_perl/Test/TCP.pm line 53.
#   Failed test 'No tests run for subtest "run_https_server"'
#   at t/11_https.t line 44.
# Tests were run but no plan was declared and done_testing() was not seen.
# Looks like your test exited with 255 just after 2.
t/11_https.t .... 
Dubious, test returned 255 (wstat 65280, 0xff00)

Version-Release number of selected component (if applicable):
0.08-10.fc32

Steps to Reproduce:
koji build --scratch f33 perl-Test-Fake-HTTPD-0.08-10.fc32.src.rpm

Additional info:
This package is tracked by Koschei. See:
https://koschei.fedoraproject.org/package/perl-Test-Fake-HTTPD

Comment 1 Jitka Plesnikova 2020-06-25 21:41:31 UTC
The failed build in rawhide
https://koji.fedoraproject.org/koji/taskinfo?taskID=46160192

Comment 2 Petr Pisar 2020-06-26 11:13:28 UTC
There are few failures on CPAN testers. I guess it's a race in lib/Test/Fake/HTTPD.pm:run() that attempt to bind to a specific TCP port:

            my $d;
            for (1..10) {
                $d = $self->_daemon_class->new(
                    LocalAddr => '127.0.0.1',
                    LocalPort => $port,
                    Timeout   => $self->{timeout},
                    Proto     => 'tcp',
                    Listen    => $self->{listen},
                    (($self->{scheme} eq 'https') ? (SSL_cert_file => $self->{cert_file}) : ()),
                    (($self->{scheme} eq 'https') ? (SSL_key_file => $self->{key_file}) : ()),
                    ($self->_is_win32 ? () : (ReuseAddr => 1)),
                    %extra_daemon_args,
                ) and last;
                Time::HiRes::sleep(0.1);
            }

            croak("Can't accepted on 127.0.0.1:$port") unless $d;

The test should either skip the test, if it cannot bind, or it should pass an already bound socket to the daemon, or it should not force a specific port and let operating system to select any free port.

Comment 3 Petr Pisar 2020-06-26 11:26:59 UTC
I could not reproduce it until I updated to these packages:

 coreutils                              x86_64            8.32-7.fc33                                            f33-perl            1.2 M
 coreutils-common                       x86_64            8.32-7.fc33                                            f33-perl            2.0 M
 crypto-policies                        noarch            20200625-1.gitb298a9e.fc33                             f33-perl             55 k
 curl                                   x86_64            7.71.0-1.fc33                                          f33-perl            302 k
 desktop-file-utils                     x86_64            0.26-1.fc33                                            f33-perl             74 k
 file                                   x86_64            5.39-2.fc33                                            f33-perl             52 k
 file-devel                             x86_64            5.39-2.fc33                                            f33-perl             17 k
 file-libs                              x86_64            5.39-2.fc33                                            f33-perl            591 k
 git-core                               x86_64            2.27.0-1.fc33.1                                        f33-perl            5.1 M
 gpm-libs                               x86_64            1.20.7-23.fc33                                         f33-perl             20 k
 libconfuse                             x86_64            3.3-1.fc33                                             f33-perl            191 k
 libconfuse-devel                       x86_64            3.3-1.fc33                                             f33-perl             21 k
 libcurl                                x86_64            7.71.0-1.fc33                                          f33-perl            273 k
 libcurl-devel                          x86_64            7.71.0-1.fc33                                          f33-perl            824 k
 libidn                                 x86_64            1.35-8.fc33                                            f33-perl            239 k
 libidn-devel                           x86_64            1.35-8.fc33                                            f33-perl            125 k
 mariadb-connector-c                    x86_64            3.1.9-1.fc33                                           f33-perl            204 k
 mariadb-connector-c-config             noarch            3.1.9-1.fc33                                           f33-perl             10 k
 mariadb-connector-c-devel              x86_64            3.1.9-1.fc33                                           f33-perl             53 k
 mt-st                                  x86_64            1.3-1.fc33                                             f33-perl             47 k
 perl-AutoLoader                        noarch            5.74-456.fc33                                          f33-perl             33 k
 perl-AutoSplit                         noarch            5.74-456.fc33                                          f33-perl             33 k
 perl-B                                 x86_64            1.80-456.fc33                                          f33-perl            193 k
 perl-Benchmark                         noarch            1.23-456.fc33                                          f33-perl             39 k
 perl-Class-Struct                      noarch            0.66-456.fc33                                          f33-perl             34 k
 perl-DynaLoader                        x86_64            1.47-456.fc33                                          f33-perl             40 k
 perl-English                           noarch            1.11-456.fc33                                          f33-perl             25 k
 perl-Errno                             x86_64            1.30-456.fc33                                          f33-perl             27 k
 perl-ExtUtils-Constant                 noarch            0.25-456.fc33                                          f33-perl             59 k
 perl-Fcntl                             x86_64            1.13-456.fc33                                          f33-perl             32 k
 perl-Fedora-VSP                        noarch            0.001-19.fc33                                          f33-perl             23 k
 perl-File-Basename                     noarch            2.85-456.fc33                                          f33-perl             29 k
 perl-File-Compare                      noarch            1.100.600-456.fc33                                     f33-perl             25 k
 perl-File-Copy                         noarch            2.34-456.fc33                                          f33-perl             32 k
 perl-File-Find                         noarch            1.37-456.fc33                                          f33-perl             37 k
 perl-File-stat                         noarch            1.09-456.fc33                                          f33-perl             29 k
 perl-FileHandle                        noarch            2.03-456.fc33                                          f33-perl             27 k
 perl-FindBin                           noarch            1.51-456.fc33                                          f33-perl             26 k
 perl-Getopt-Std                        noarch            1.12-456.fc33                                          f33-perl             27 k
 perl-HTTP-Tiny                         noarch            0.076-456.fc33                                         f33-perl             55 k
 perl-Hash-Util                         x86_64            0.23-456.fc33                                          f33-perl             47 k
 perl-Hash-Util-FieldHash               x86_64            1.20-456.fc33                                          f33-perl             50 k
 perl-I18N-LangTags                     noarch            0.44-456.fc33                                          f33-perl             67 k
 perl-IO                                x86_64            1.43-456.fc33                                          f33-perl             99 k
 perl-IPC-Open3                         noarch            1.21-456.fc33                                          f33-perl             35 k
 perl-Locale-Maketext-Simple            noarch            1:0.21-456.fc33                                        f33-perl             29 k
 perl-Math-Complex                      noarch            1.59-456.fc33                                          f33-perl             59 k
 perl-NDBM_File                         x86_64            1.15-456.fc33                                          f33-perl             34 k
 perl-POSIX                             x86_64            1.94-456.fc33                                          f33-perl            110 k
 perl-Pod-Html                          noarch            1.25-456.fc33                                          f33-perl             38 k
 perl-SelectSaver                       noarch            1.02-456.fc33                                          f33-perl             23 k
 perl-Symbol                            noarch            1.08-456.fc33                                          f33-perl             26 k
 perl-Sys-Hostname                      x86_64            1.23-456.fc33                                          f33-perl             29 k
 perl-Test                              noarch            1.31-456.fc33                                          f33-perl             40 k
 perl-Thread-Semaphore                  noarch            2.13-456.fc33                                          f33-perl             27 k
 perl-Tie                               noarch            4.6-456.fc33                                           f33-perl             43 k
 perl-Tie-RefHash                       noarch            1.39-456.fc33                                          f33-perl             27 k
 perl-Time-Piece                        x86_64            1.3401-456.fc33                                        f33-perl             54 k
 perl-base                              noarch            2.27-456.fc33                                          f33-perl             28 k
 perl-blib                              noarch            1.07-456.fc33                                          f33-perl             24 k
 perl-deprecate                         noarch            0.04-456.fc33                                          f33-perl             26 k
 perl-devel                             x86_64            4:5.32.0-456.fc33                                      f33-perl            675 k
 perl-diagnostics                       noarch            1.37-456.fc33                                          f33-perl            222 k
 perl-doc                               noarch            5.32.0-456.fc33                                        f33-perl            4.5 M
 perl-generators                        noarch            1.11-7.fc33                                            f33-perl             16 k
 perl-if                                noarch            0.60.800-456.fc33                                      f33-perl             26 k
 perl-interpreter                       x86_64            4:5.32.0-456.fc33                                      f33-perl             84 k
 perl-lib                               x86_64            0.65-456.fc33                                          f33-perl             27 k
 perl-libs                              x86_64            4:5.32.0-456.fc33                                      f33-perl            2.1 M
 perl-locale                            noarch            1.09-456.fc33                                          f33-perl             25 k
 perl-macros                            noarch            4:5.32.0-456.fc33                                      f33-perl             22 k
 perl-mro                               x86_64            1.23-456.fc33                                          f33-perl             40 k
 perl-open                              noarch            1.12-456.fc33                                          f33-perl             28 k
 perl-overload                          noarch            1.31-456.fc33                                          f33-perl             58 k
 perl-overloading                       noarch            0.02-456.fc33                                          f33-perl             25 k
 perl-srpm-macros                       noarch            1-37.fc33                                              f33-perl            8.4 k
 perl-subs                              noarch            1.03-456.fc33                                          f33-perl             23 k
 perl-vars                              noarch            1.05-456.fc33                                          f33-perl             25 k
 python3-file-magic                     noarch            5.39-2.fc33                                            f33-perl             19 k
 python3-rpm                            x86_64            4.16.0-0.beta3.1.fc33                                  f33-perl            100 k
 rpm                                    x86_64            4.16.0-0.beta3.1.fc33                                  f33-perl            504 k
 rpm-build                              x86_64            4.16.0-0.beta3.1.fc33                                  f33-perl             97 k
 rpm-build-libs                         x86_64            4.16.0-0.beta3.1.fc33                                  f33-perl            100 k
 rpm-devel                              x86_64            4.16.0-0.beta3.1.fc33                                  f33-perl             86 k
 rpm-libs                               x86_64            4.16.0-0.beta3.1.fc33                                  f33-perl            336 k
 rpm-plugin-selinux                     x86_64            4.16.0-0.beta3.1.fc33                                  f33-perl             23 k
 rpm-plugin-systemd-inhibit             x86_64            4.16.0-0.beta3.1.fc33                                  f33-perl             24 k
 rpm-sign-libs                          x86_64            4.16.0-0.beta3.1.fc33                                  f33-perl             28 k
 rubygems                               noarch            3.1.4-200.fc33                                         f33-perl            285 k
 selinux-policy                         noarch            3.14.6-16.fc33                                         f33-perl            100 k
 selinux-policy-targeted                noarch            3.14.6-16.fc33                                         f33-perl            8.1 M
 sqlite-libs                            x86_64            3.32.3-1.fc33                                          f33-perl            614 k
 vim-common                             x86_64            2:8.2.1052-1.fc33                                      f33-perl            6.5 M
 vim-enhanced                           x86_64            2:8.2.1052-1.fc33                                      f33-perl            1.5 M
 vim-filesystem                         noarch            2:8.2.1052-1.fc33                                      f33-perl             22 k

Comment 4 Petr Pisar 2020-06-26 11:40:16 UTC
It's triggered by upgrading crypto-policies from 20200610-1.git7f9d474.fc33 to 20200625-1.gitb298a9e.fc33. Changelog:

* Thu Jun 25 2020 Tomáš Mráz <tmraz@redhat.com> - 20200625-1.gitb298a9e
- DEFAULT policy: Drop DH < 2048 bits, TLS 1.0, 1.1, SHA-1
- make the NEXT policy just an alias for DEFAULT as they are now identical
- policies: introduce sha1_in_dnssec value for BIND
- add SHA1 and FEDORA32 policy modules to provide backwards compatibility
  they can be applied as DEFAULT:SHA1 or DEFAULT:FEDORA32
- avoid duplicates of list items in resulting policy

* Wed Jun 24 2020 Tomáš Mráz <tmraz@redhat.com> - 20200619-1.git781bbd4
- gnutls: enable DSA signatures in LEGACY

* Wed Jun 10 2020 Tomáš Mráz <tmraz@redhat.com> - 20200610-1.git7f9d474

I guess the bundled testing keys do pass the new criteria.


Note You need to log in before you can comment on or make changes to this bug.